{-# OPTIONS --universe-polymorphism #-}

module Basics where

data Level : Set where
  zl : Level
  sl : Level -> Level

{-# BUILTIN LEVEL Level #-}
{-# BUILTIN LEVELZERO zl #-}
{-# BUILTIN LEVELSUC sl #-}


id : {a : Level}{X : Set a} -> X -> X
id x = x

_o_ : ∀ {a b c}
        {A : Set a} {B : A → Set b} {C : {x : A} → B x → Set c} →
      (∀ {x} (y : B x) → C y) → (g : (x : A) → B x) →
      ((x : A) → C (g x))
f o g = λ x → f (g x)
infixl 5 _o_

record Sg (S : Set)(T : S -> Set) : Set where
  constructor _,_
  field
    fst : S
    snd : T fst
open Sg public
infixr 4 _,_

_*_ : Set -> Set -> Set
S * T = Sg S \ _ -> T

record One : Set where constructor <>

data _==_ {l : Level}{X : Set l}(x : X) : X -> Set l where
 refl : x == x

infixr 2 _==_