module Brady where

open import Basics
open import Desc
open import MapFold
open import Orn

chosen :  forall {I J X}{f : J -> I}{D : Desc I}(O : Orn f D) ->
          [ D ] X -> Orn {J = Sg J (X o f)} fst (od O)
chosen (var (ok j)) x = var (ok (j , x))
chosen one <> = one
chosen (O ** Q) (xs , ys) = chosen O xs ** chosen Q ys
chosen (pi S O) g = pi S \ s -> chosen (O s) (g s)
chosen (sg S O) (s , xs) = del s (chosen (O s) xs)
chosen (ins S O) xs = sg S (\ s -> chosen (O s) xs)
chosen {I}{J}{X}{f}(del {S} s {D} O) (s' , xs)
  = ins (s == s') \ q -> help s s' q O xs where
    help : (s s' : S) -> s == s' -> (O : Orn f (D s)) -> [ D s' ] X ->
           Orn {J = Sg J (X o f)} fst (od O)
    help s .s refl O xs = chosen O xs

bradyOrn :  forall {I J}{f : J -> I}(F : I <! I) ->
            (O : FOrn f F) ->
            FOrn {J = Sg J (Mu F o f)} fst (of F O)
bradyOrn F O (j , < ns >) = chosen (O j) ns 

VECO : (X : Set) -> FOrn {J = One * Nat} fst (LIST X)
VECO X = bradyOrn NAT (LISTO X)

VEC : Set -> (One * Nat) <! (One * Nat)
VEC X = of (LIST X) (VECO X)

Vec : Set -> Nat -> Set
Vec X n = Mu (VEC X) (<> , n)

nilv : forall {X} -> Vec X zero
nilv = < <> >

_:v:_ : forall {X n} -> X -> Vec X n -> Vec X (suc n)
x :v: xs = < x , xs >

toList : forall {X n} -> Vec X n -> List X
toList {X} = forget (LIST X) (VECO X)
