{-# OPTIONS --universe-polymorphism #-}

module Desc where

open import Basics

data Desc (I : Set) : Set1 where
  var : (i : I) -> Desc I
  sg pi : (S : Set)(D : S -> Desc I) -> Desc I
  _**_ : (D E : Desc I) -> Desc I
  one : Desc I

[_] : {I : Set} -> Desc I -> (I -> Set) -> Set
[ var i  ] X  =  X i
[ sg S D ] X  =  Sg S \ s -> [ D s ] X
[ pi S D ] X  =  (s : S) -> [ D s ] X
[ D ** E ] X  =  [ D ] X * [ E ] X
[ one    ] X  =  One

_<!_ : Set -> Set -> Set1
O <! I = O -> Desc I

-- F_0 I = I <! I

[_o] : forall {I O} -> (O <! I) -> (I -> Set) -> (O -> Set)
[ F o] X i = [ F i ] X

data Mu {I : Set}(F : I <! I)(i : I) : Set where
  <_> : [ F i ] (Mu F) -> Mu F i

-- better have an example

data ZeSu : Set where ze su : ZeSu

ze->_su->_ : forall {l}{P : ZeSu -> Set l} -> P ze -> P su -> (x : ZeSu) -> P x
(ze-> z su-> s) ze = z
(ze-> z su-> s) su = s

NAT : One <! One
NAT _ = sg ZeSu (ze-> one  su-> var <>)

Nat : Set
Nat = Mu NAT <>

zero : Nat
zero = < ze , <> >

suc : Nat -> Nat
suc n = < su , n >

-- here's a dependent example, balanced trees

TREE : Set -> Nat <! Nat
TREE X < ze , <> > = sg X \ _ -> one
TREE X < su , n  > = var n ** var n

Tree : Set -> Nat -> Set
Tree X = Mu (TREE X)

leaf : forall {X} -> X -> Tree X zero
leaf x = < x , <> >

node : forall {X n} -> Tree X n -> Tree X n -> Tree X (suc n)
node l r = < l , r >
