{-# OPTIONS --universe-polymorphism #-}

module MapFold where

open import Basics
open import Desc

_-:>_ : {I : Set}(X Y : I -> Set) -> Set
X -:> Y = forall {i} -> X i -> Y i

map : forall {I}(D : Desc I){X Y} -> X -:> Y -> [ D ] X -> [ D ] Y
map  (var i)   f  x            =  f x
map  (sg S D)  f  (s , xs)     =  s , map (D s) f xs
map  (pi S D)  f  g            =  \ s -> map (D s) f (g s)
map  (D ** E)  f  (xs , xs')   =  map D f xs , map E f xs'
map  one       f  <>           =  <>

{-
fold : forall {I X}(F : I <! I)
       (phi : [ F o] X -:> X) ->
       Mu F -:> X
fold F phi {i} < ns > = phi (map (F i) (fold F phi) ns)
-}

mutual
  fold : forall {I X}(F : I <! I)
         (phi : [ F o] X -:> X) ->
         Mu F -:> X
  fold F phi {i} < ts > = phi (mapF (F i) F phi ts)
  mapF : forall {I X}(D : Desc I)(F : I <! I)
         (phi : [ F o] X -:> X) ->
         [ D ] (Mu F) -> [ D ] X
  mapF (var i)  F phi x          =  fold F phi x
  mapF (sg S D) F phi (s , xs)   =  s , mapF (D s) F phi xs
  mapF (pi S D) F phi g          =  \ s -> mapF (D s) F phi (g s)
  mapF (D ** E) F phi (xs , xs') =  mapF D F phi xs , mapF E F phi xs'
  mapF one      F phi <>         =  <>
