{-# OPTIONS --universe-polymorphism #-}

module Orn where

open import Basics
open import Desc
open import MapFold

data _^-1_ {J I : Set}(f : J -> I) : I -> Set where
  ok : (j : J) -> f ^-1 (f j)

data Orn {J I : Set}(f : J -> I) : Desc I -> Set1 where
  var   :  forall {i}(j : f ^-1 i) -> Orn f (var i)
  one   :  Orn f one
  _**_  :  forall {D E}(O : Orn f D) -> (Q : Orn f E) ->
           Orn f (D ** E)

  pi    :  (S : Set) -> forall {D} ->
           (O : (s : S) -> Orn f (D s)) ->
           Orn f (pi S D)

  sg    :  (S : Set) -> forall {D} ->
           (O : (s : S) -> Orn f (D s)) ->
           Orn f (sg S D)

  ins   :  (S : Set) -> forall {D} ->
           (O : (s : S) -> Orn f D) ->
           Orn f D

  del   :  {S : Set}(s : S) -> forall {D} ->
           (O : Orn f (D s)) ->
           Orn f (sg S D)

{-  -- why not just define?
sg' :  forall {J I}{f : J -> I}(S : Set) -> forall {D} ->
       ((s : S) -> Orn f (D s)) ->
       Orn f (sg S D)
sg' S O = ins S \ s -> del s (O s)
-}

FOrn : forall {I J}(f : J -> I)(F : I <! I) -> Set1
FOrn {J = J} f F = (j : J) -> Orn f (F (f j))

od : forall {J I}{f : J -> I}{D : Desc I} -> Orn f D -> Desc J
od (var (ok j))  = var j
od one           = one
od (O ** Q)      = od O ** od Q
od (pi S O)      = pi S \ s -> od (O s)
od (sg S O)      = sg S \ s -> od (O s)
od (ins S O)     = sg S \ s -> od (O s)
od (del s O)     = od O

of : forall {I J}{f : J -> I}(F : I <! I) -> FOrn f F -> J <! J
of F O j = od (O j)

-- example, please!

LISTO : Set -> FOrn id NAT
LISTO X j = sg ZeSu (ze-> one   su-> ins X \ _ -> var (ok <>))

LIST : Set -> One <! One
LIST X = of NAT (LISTO X)

List : Set -> Set
List X = Mu (LIST X) <>

nill : {X : Set} -> List X
nill = < ze , <> >

_:l:_ : {X : Set} -> X -> List X -> List X
x :l: xs = < su , x , xs >
infixr 3 _:l:_

-- what does it gain us?

erase : forall {I J}{f : J -> I}{D : Desc I}(O : Orn f D) ->
        {X : I -> Set} -> [ od O ] (X o f) -> [ D ] X
erase  (var (ok j))  x          = x
erase  one           <>         = <>
erase  (O ** Q)      (xs , ys)  = erase O xs , erase Q ys
erase  (pi S O)      g          = \ s -> erase (O s) (g s)
erase  (sg S O)      (s , xs)   = s , erase (O s) xs
erase  (ins S O)     (s , xs)   = erase (O s) xs
erase  (del s O)     xs         = s , erase O xs

ornAlg : forall {I J}{f : J -> I}(F : I <! I) ->
         (O : FOrn f F) ->
         [ of F O o] (Mu F o f) -:> (Mu F o f)
ornAlg F O {j} ns = < erase (O j) ns >

forget : forall {I J}{f : J -> I}(F : I <! I) ->
         (O : FOrn f F) ->
         Mu (of F O) -:> (Mu F o f)
forget F O = fold (od o O) (ornAlg F O)


-- so, in particular

length : {X : Set} -> List X -> Nat
length {X} = forget NAT (LISTO X)
